curl --request POST \
--url https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"batch": [
{
"type": "identify",
"userId": "user_12345",
"traits": {
"email": "ada@example.com"
}
},
{
"type": "track",
"userId": "user_12345",
"event": "Order Completed",
"properties": {
"total": 129,
"currency": "USD"
}
}
],
"context": {
"app": {
"version": "3.2.1"
}
},
"sentAt": "2026-10-11T09:25:00.000Z"
}
'import requests
url = "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch"
payload = {
"batch": [
{
"type": "identify",
"userId": "user_12345",
"traits": { "email": "ada@example.com" }
},
{
"type": "track",
"userId": "user_12345",
"event": "Order Completed",
"properties": {
"total": 129,
"currency": "USD"
}
}
],
"context": { "app": { "version": "3.2.1" } },
"sentAt": "2026-10-11T09:25:00.000Z"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
batch: [
{type: 'identify', userId: 'user_12345', traits: {email: 'ada@example.com'}},
{
type: 'track',
userId: 'user_12345',
event: 'Order Completed',
properties: {total: 129, currency: 'USD'}
}
],
context: {app: {version: '3.2.1'}},
sentAt: '2026-10-11T09:25:00.000Z'
})
};
fetch('https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'batch' => [
[
'type' => 'identify',
'userId' => 'user_12345',
'traits' => [
'email' => 'ada@example.com'
]
],
[
'type' => 'track',
'userId' => 'user_12345',
'event' => 'Order Completed',
'properties' => [
'total' => 129,
'currency' => 'USD'
]
]
],
'context' => [
'app' => [
'version' => '3.2.1'
]
],
'sentAt' => '2026-10-11T09:25:00.000Z'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch"
payload := strings.NewReader("{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}"
response = http.request(request)
puts response.read_body{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "RATE_LIMITED",
"message": "<string>",
"status": 429,
"retry_after": 2
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}Ingest a batch of CDP events
Ingest up to 200 Segment-compatible events in one call under the tenant’s ingest source ingest_id — body carries batch[] of track / identify / page / screen / group / alias items (each with its own type), plus optional shared context and sentAt. Authenticates with HMAC-SHA256 of the raw body using the source’s ingest secret, so a tampered item invalidates the whole batch; per-item outcomes are reported in order. Use it for bulk flushes from mobile SDKs and queue drains instead of one HTTP call per event.
curl --request POST \
--url https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"batch": [
{
"type": "identify",
"userId": "user_12345",
"traits": {
"email": "ada@example.com"
}
},
{
"type": "track",
"userId": "user_12345",
"event": "Order Completed",
"properties": {
"total": 129,
"currency": "USD"
}
}
],
"context": {
"app": {
"version": "3.2.1"
}
},
"sentAt": "2026-10-11T09:25:00.000Z"
}
'import requests
url = "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch"
payload = {
"batch": [
{
"type": "identify",
"userId": "user_12345",
"traits": { "email": "ada@example.com" }
},
{
"type": "track",
"userId": "user_12345",
"event": "Order Completed",
"properties": {
"total": 129,
"currency": "USD"
}
}
],
"context": { "app": { "version": "3.2.1" } },
"sentAt": "2026-10-11T09:25:00.000Z"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
batch: [
{type: 'identify', userId: 'user_12345', traits: {email: 'ada@example.com'}},
{
type: 'track',
userId: 'user_12345',
event: 'Order Completed',
properties: {total: 129, currency: 'USD'}
}
],
context: {app: {version: '3.2.1'}},
sentAt: '2026-10-11T09:25:00.000Z'
})
};
fetch('https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'batch' => [
[
'type' => 'identify',
'userId' => 'user_12345',
'traits' => [
'email' => 'ada@example.com'
]
],
[
'type' => 'track',
'userId' => 'user_12345',
'event' => 'Order Completed',
'properties' => [
'total' => 129,
'currency' => 'USD'
]
]
],
'context' => [
'app' => [
'version' => '3.2.1'
]
],
'sentAt' => '2026-10-11T09:25:00.000Z'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch"
payload := strings.NewReader("{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.orbit.devotel.io/cdp/v1/{ingest_id}/batch")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"batch\": [\n {\n \"type\": \"identify\",\n \"userId\": \"user_12345\",\n \"traits\": {\n \"email\": \"ada@example.com\"\n }\n },\n {\n \"type\": \"track\",\n \"userId\": \"user_12345\",\n \"event\": \"Order Completed\",\n \"properties\": {\n \"total\": 129,\n \"currency\": \"USD\"\n }\n }\n ],\n \"context\": {\n \"app\": {\n \"version\": \"3.2.1\"\n }\n },\n \"sentAt\": \"2026-10-11T09:25:00.000Z\"\n}"
response = http.request(request)
puts response.read_body{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "RATE_LIMITED",
"message": "<string>",
"status": 429,
"retry_after": 2
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}{
"error": {
"code": "<string>",
"message": "<string>",
"status": 123,
"details": {}
},
"meta": {
"request_id": "<string>",
"timestamp": "2023-11-07T05:31:56Z",
"docs_url": "<string>"
}
}Authorizations
Dashboard JWT token from Clerk
Headers
Stripe-style idempotency token. Pass a stable, client-generated value (1-255 chars) to dedupe retries on transient timeouts. The same key+credential+path replays the original response for 24h on 2xx (5min on 4xx, 30s on 5xx). Returns 409 if a concurrent request with the same key is already in flight; replayed responses include the Idempotency-Replay: true response header.
1 - 255Sandbox opt-in for Clerk-session-authenticated requests — see Test mode explained for the full credential-header matrix and worked samples. Set to true to route the call through the test-mode pipeline: no real provider delivery, no credits deducted, response meta.test_mode: true. Ignored for live API keys (dv_live_sk_*) — server-to-server clients must use a test-prefixed key (dv_test_sk_*) to exercise sandbox. Test-prefixed keys unconditionally enable sandbox regardless of this header.
true, false Path Parameters
Body
Up to 200 events, each a track / identify / page / screen / group / alias item carrying its own type field.
200[
{
"type": "identify",
"userId": "user_12345",
"traits": { "email": "ada@example.com" }
},
{
"type": "track",
"userId": "user_12345",
"event": "Order Completed",
"properties": { "total": 129, "currency": "USD" }
}
]
Shared Segment context applied to every item.
{ "app": { "version": "3.2.1" } }
When the batch was sent (ISO 8601).
"2026-10-11T09:25:00.000Z"
Response
The batch acknowledgement — received, the processed count, and the ordered per-item results — in the standard { data, meta } envelope.